// -*- c++ -*-
#include <stdlib.h>
#include <assert.h>
// -------------------------------------------
//  Kris and some fool who writes bad code
//  
// -------------------------------------------
// #ifndef __sgi
// #define CAS(V,O,N) ((*(long*)(V)==(long)(O))?(*(long*)(V)=(long)(N),1) : 0)
// #else
// #define CAS(V,O,N) __compare_and_swap((long*)V,(long)O,(long)N)
// #endif
#define DEBUGHANDLE(X) cout << "handle.h - "; X 
//#define DEBUGHANDLE(X)
//#define inline

#ifndef __sgi
template <class T>
bool CAS(T*v, const T &o, const T &n)
{
  DEBUGHANDLE(cout << "CAS - Solaris old =" << o << " new = " << n << endl); 
  if (*v == o){
    *v = n;
    return true;
  } 
  return false;
}
#else 
template <class T>
bool CAS(T*v, const T& o, T n)
{
  DEBUGHANDLE(cout << "CAS - Crunch old =" << o << " new = " << n << endl); 
  T t = *v;
  bool r = __compare_and_swap((long*)v,(long)o,(long)n);
  if (r) {
    t --;
    n ++;
  }
  return r;
}
//CAS(V,O,N) __compare_and_swap((long*)V,(long)O,(long)N)
#endif

template <class T> class handle;
// template <class T>
// void Fake_Dec(handle<T> &x)//wfqueue<int>::nodeptr
// {
//  
// }



#define ACTIVE 1
#define DELETE 0
#define FREELIST 1024*1024*1/sizeof(handle<T>::node)

template<class T>
inline int INC(T&val) {
  int valAct = val;
  while (!CAS(&val, valAct, valAct+1))
    valAct = val;
  return valAct;
}

template<class T>
inline int DEC(T&val) {
  int valAct = val;
  while (!CAS(&val, valAct, valAct-1))
    valAct = val;
  return valAct;
}

template<class T>
class handle
{
public:

  struct node {
    node *   next;
    unsigned short    ID;
    //int    status;
    int    count;
    T      value;

    node () {} 
    node (const T&v) : value (v) {}
  };


public:

  
  handle(const T&);
  handle(const handle<T>&);
  handle();
  ~handle();

  void delete_handle();
  bool check_live() const;
  // void print_state();

  void operator = (const T&q);
  void operator = (const handle<T>&q);
  void operator = (const int q);
  bool operator == (const handle<T>&q) const;
  bool operator == (const int q) const;
  bool operator != (const int q) const;
  bool operator != (const handle<T>&q) const;
  T* operator -> ();
  T& operator * ();
  void operator -- (int);
  void operator ++ (int);
  operator long () const {return offset << 16 | ID;}
  //overload =, ==, and anything else a pointer could do.

  void print_state(ostream&o) const;

private:
  void initialize(const T&);
  void increment ();

  static node * free_list;
  static node * memory_begin;
  static int ID_Source;

  static node* nextfree () { 
    node  *t;
    DEBUGHANDLE(cout << "FREELIST - node * nextfree() - Begin " << endl);
    if (free_list == 0) {
      cerr << "Free list exhausted" << endl;
      exit (0);
    }
    for (;;) {
      t = free_list; 
      if (CAS(&free_list, t, t->next))
	break;
    }
    t->ID = INC(ID_Source);
    //assert(t->status==DELETE);
    t->next=0;
    //Perhap put as t->next = 0 here.  Maybe
    DEBUGHANDLE(cout << "FREELIST - node * nextfree() - End " << endl);
    return t;
  }

  static void putfree (node*p) { 
    DEBUGHANDLE(cout << "FREELIST - void putfree() - Begin " << endl);
   DEBUGHANDLE(cout << "Put Free" << endl);
    node *list;
    //assert(p->status==DELETE);
    for (;;) {
      list = free_list;
      p->next = list; 
      if (CAS (&free_list, list, p))
	break;
    }    
    DEBUGHANDLE(cout << "FREELIST - void putfree() - End " << endl);
  }

  static void init_free() {
    init_free(FREELIST);
  }
  
  static void init_free(int free_size) {
    DEBUGHANDLE(cout << "FREELIST - void init_free(int free_size) - Begin " << endl);
    ID_Source = 1;

    node *n =  (node*)new char [sizeof (node) *free_size];
    memory_begin = n;
    free_list = n;
    n->count=0;
    //n->status=DELETE;
    n->ID=0;
    for (int x=1; x < free_size; x++){
      n-> next = &free_list[x];
      n  = n ->next;
      n ->count=0;
      //n->status=DELETE;
      n ->ID = 0;
    }
    n -> next = 0;
    //n->status=DELETE;
    n->count=0;
    n-> ID = 0;
    DEBUGHANDLE(cout << "FREELIST - void init_free(int free_size) - End " << endl);
  }

public:
  
  unsigned short offset;
  unsigned short ID;
   
};

template<class T>
handle<T>::node * handle<T>::free_list = 0;

template<class T>
handle<T>::node * handle<T>::memory_begin = 0;

template<class T>
int handle<T>::ID_Source = 1;

#if 0
template<class T>
void handle<T>::allocate ()
{
  DEBUGHANDLE(cout << "handle<T>::allocate() - BEGIN" << endl);
  if (free_list == 0) 
    init_free();

  node* n = nextfree(); 
  //ok, now I have the next one
  //ok, now someone might be in here, but it shouldn't matter
  if (INC(n->count)!=0)  //do not remove, la INC es importante
    cerr << "WARNING:  NODE FROM FREELIST WAS ACCESSED - INITIALIZED TO " << n->count << endl;
  //n->status = ACTIVE;
  ID = n->ID;
  DEBUGHANDLE(cout << n << endl);
  DEBUGHANDLE(cout << memory_begin << endl);
  DEBUGHANDLE(cout << n-memory_begin << endl);
  offset = n - memory_begin;  //this is so I can hold the value in a 16-bit place to CAS on.
  //ok, this node has been set. 
  DEBUGHANDLE(cout << *this << endl);
  DEBUGHANDLE(cout << "handle<T>::allocate() - END" << endl);   
}
#endif

template<class T>
void handle<T>::operator = (const handle<T>&q)
{
  DEBUGHANDLE(cout << "handle<T>::operator = (const handle<T>&q) - Begin" << endl);
  delete_handle();
  //this is the copy routine
  //increment counter on original, 
  //check deleted - I cannot check ID, but
  //I don't have too.

  ID = q.ID;
  offset = q.offset;
  //ok, now I need to increment the count
  increment ();

  //I think it is ok to have this pointer, since the guy copying has it too.
  DEBUGHANDLE(cout << "handle<T>::operator = (const handle<T>&q) - End" << endl);
}

template<class T>
void handle<T>::operator = (const int q)
{
  DEBUGHANDLE(cout << "handle<T>::operator (const int q) = - Begin" << endl);
  assert(q==0);
  delete_handle();
  //this is the copy routine
  //increment counter on original, 
  //check deleted - I cannot check ID, but
  //I don't have too.

  ID = q;
  offset = 0;
  DEBUGHANDLE(cout << "handle<T>::operator (const int q) = - End" << endl);
}


template<class T>
//inline
bool handle<T>::operator == (const handle<T>&q) const
{
  return ((offset==q.offset) && (ID==q.ID));
}

template<class T>
//inline
bool handle<T>::operator == (const int q) const
{
  assert(q==0);
  return (ID==q);
}

template<class T>
//inline
bool handle<T>::operator != (const handle<T>&q) const
{
  return ((ID!=q.ID));
}

template<class T>
//inline
bool handle<T>::operator != (const int q) const
{
  assert(q==0);
  return (ID!=0);
}

template<class T>
//inline
T* handle<T>::operator -> ()
{
  DEBUGHANDLE(cout << "handle<T>::operator -> Begin" << endl);
  node *n = memory_begin + offset;
  DEBUGHANDLE(cout << "handle<T>::operator -> End" << endl);
  return &n->value;
}

template<class T>
//inline
T& handle<T>::operator * ()
{
  DEBUGHANDLE(cout << "handle<T>::operator * Begin" << endl);
  node *n = memory_begin + offset;
  DEBUGHANDLE(cout << "handle<T>::operator * End" << endl);
  return n->value;
}

template<class T>
//inline
void handle<T>::operator -- (int) 
{  
   DEBUGHANDLE(cout << "handle<T>::operator -- Begin" << endl);
   delete_handle(); 
   DEBUGHANDLE(cout << "handle<T>::operator -- End" << endl);
}

template<class T>
//inline
void handle<T>::operator ++ (int) 
{  
   DEBUGHANDLE(cout << "handle<T>::operator -- Begin" << endl);
   increment(); 
   DEBUGHANDLE(cout << "handle<T>::operator -- End" << endl);
}

template<class T>
void handle<T>::increment() 
{
  if (check_live()) {
    node *n;
    n = memory_begin + offset;
    //ok, now increment
    INC(n->count);
  }
}

template<class T>
void handle<T>::initialize(const T&q) 
{
  DEBUGHANDLE(cout << "handle::initialize - Begin" << endl);
  if (free_list == 0) 
    init_free();

  node *n = nextfree ();
 
  DEBUGHANDLE(cout << "handle::initialize construct node begin" << endl);
  //construct<node,T> (n, q);
    new (n) node (q);
  DEBUGHANDLE(cout << "handle::initialize construct node end" << endl);

  //ok, now I have the next one
  //ok, now someone might be in here, but it shouldn't matter
  if (INC(n->count)!=0)  //do not remove, la INC es importante
    cerr << "WARNING:  NODE FROM FREELIST WAS ACCESSED - INITIALIZED TO " 
	 << n->count << endl;
  
  offset = n - memory_begin;
  ID     = n -> ID;
  
  //   allocate();
  //   node* n = memory_begin + offset;
  
  //  construct (&n->value, q);
  //  n->value = q;
  
  DEBUGHANDLE(cout << "handle::initilize - End" << endl);
}

template<class T>
//inline
handle<T>::handle(const T &q)
{
  DEBUGHANDLE(cout << "handle::handle(const T &q) - Begin" << endl);
  
  initialize (q);
  
  DEBUGHANDLE(cout << "handle::handle(const T &q) - End" << endl);
}


template<class T>
//inline
void handle<T>::operator = (const T &q)
{
  DEBUGHANDLE(cout << "handle::operator = (T&q) - Begin" << endl);
  delete_handle();
  initialize (q);
  DEBUGHANDLE(cout << "handle::operator = (T&q) - end" << endl);
}

template<class T>
//inline
handle<T>::~handle ()
{
  DEBUGHANDLE(cout << "handle::~handle() - Begin" << endl);
  delete_handle(); 
  DEBUGHANDLE(cout << "handle::~handle() - End" << endl);
}

template<class T>
void handle<T>::delete_handle()
{
  DEBUGHANDLE(cout << "void handle<T>::delete_handle() - Begin on:"  << *this << endl);
  if (!check_live())
    return;
  node *n;
  // assert((offset > 0) && (offset < FREELIST));
  n = memory_begin + offset;
  if (DEC(n->count)==1) {
    //destroy <node> (n);
     n->~node ();
    putfree(n);
  }
 DEBUGHANDLE(cout << "destroy " << *this << endl);
  DEBUGHANDLE(cout << "void handle<T>::delete_handle() - End" << endl);
}

template<class T>
bool handle<T>::check_live() const
{
  //DEBUGHANDLE(cout << "void handle<T>::check_live() - Begin on:" << endl);
  if (ID==0)
    return false;
  node *n;
  n = memory_begin + offset;

  //DEBUGHANDLE(cout << "void handle<T>::check_live() - End" << endl);
  if (n->ID!=ID)
    return false;
  return true;
}

// template<class T>
// void handle<T>::print_state()
// {
//   //don't call this.
//   a =  new int [10];
//   DEBUGHANDLE(cout << "void handle<T>::print_state() - Begin on:"  << *this << endl);
//   for (int x=0; x < free_size; x++){
//     n = &free_list[x];
//     if (n ->count!=0) {
//       a[n->value]++;
//     }
//   }
//   DEBUGHANDLE(cout << "void handle<T>::print_state() - End" << endl);
// }

template<class T>
handle<T>::handle(const handle<T>&q) 
{
  DEBUGHANDLE(cout << "handle<T>::handle(const handle<T>&q) - Begin" << endl);
  //this is the copy routine
  //increment counter on original, 
  //check deleted - I cannot check ID, but
  //I don't have too.

  ID = q.ID;
  offset = q.offset;
  //ok, now I need to increment the count
  if (check_live()) {
    node *n;
    n = memory_begin + offset;
    //ok, now increment
    INC(n->count);
    DEBUGHANDLE(cout << "handle<T>::handle(const handle<T>&q) inc" << *this << endl);
    //ok, now that we are in, is it still valid?
    if (!check_live())
      delete_handle();
    //ok, do I leave them with a dead handle here?
  }
  //I think it is ok to have this pointer, since the guy copying has it too.
  DEBUGHANDLE(cout << "handle<T>::handle(const handle<T>&q) - End" << endl);
}

template<class T>
handle<T>::handle() 
{
  DEBUGHANDLE(cout << "handle<T>::handle() - Begin" << endl);
  ID = 0;
  offset = 0;
  DEBUGHANDLE(cout << "handle<T>::handle() - End" << endl);
}

template<class T>
void handle<T>::print_state(ostream&o) const 
{
  if (check_live()) {
    node *n;
    n = memory_begin + offset;
    o << "ID:" << ID << " OFFSET:" << offset << " COUNT:" << n->count;
  }  
  else
     o << "ID:" << ID << " OFFSET:" << offset << " NO COUNT, NULL POINTER";
}

template<class T>
ostream& operator << (ostream&o, const handle<T>& q)
{
  q.print_state(o);
  return o;
}

