// -*- c++ -*-

#include <iostream.h>
#include "tcb.h"
#include "wfqueue.h"


#define ITEMS 10

int free_list_sz = 0;

static int counter[10];

static int count;

inline int random_between (int low, int high)
{
  return (int)((double)random()/INT_MAX * (high-low) + low);
}


int work () {
  int w = random_between (0, 1000);

  for (int x = 0; x < w; x++)
    ;
 
 return 0;
}

void fillqueue(wfqueue<int> & q, int r)
{
  //int x =0;
  wfqueue<int>::token tok;
  for (int i=0; i < ITEMS; i ++) {
    q.gettoken (tok);
        cerr << r ;
    //    cerr.flush();
    work();
    //int t =random_between(0,9);
    int t = r;
    if (q.insert (t, tok)) {
      //INC(x);
      INC(counter[t]);
      cout << "inserted " << t << endl;
    }
    else {
      cout << "insert failed " << endl;
    }
  }
  //cout << "x = " << x << endl;
}


void remqueue(wfqueue<int> & q, int r)
{
  int x;
  //int county = 0;
  wfqueue<int>::token tok;
  for (int i=0; i < ITEMS; i ++) {
    cerr << r;
//    cerr.flush();

    q.peek (x, tok);
    //cout << "peeked x = " << x <<  " with toke = " << tok << endl;
    x=-1;
    work();
    if (q.remove (x, tok)) {
      cout << "removed " << x << " with tok =" << tok << endl;
      DEC(counter[x]);
    }
    else {
      cout << "remove failed with tok =" << tok << endl;
    }

  }
  // cout << "r = " << county << endl;
}


class queuefiller : public thread_task
{
public:
  queuefiller (wfqueue<int> &q, int count) : queue (q) {
    b1.set_size(count);
    b2.set_size(count);
  }

  void action (int rank) {
    //cerr << "action";
    b1.wait ();
    
    if (rank % 2) {
      remqueue (queue, rank);
    } else {
      fillqueue (queue, rank);
    }

    b2.wait();
  }

private:

  wfqueue<int> &queue;

  static thread_barrier b1;
  static thread_barrier b2;
};

thread_barrier queuefiller::b1;
thread_barrier queuefiller::b2;


thread_control TCB;

void 
main(int argc, char **argv)
{
  cout << "TESTING:::  BEGINNING" << endl;
  int c;
  int threads = 1;
  wfqueue<int> q;

  for (int i = 0; i<10; i++) {
    counter[i]=0;
  }

  while ((c = getopt (argc, argv, "t:")) != EOF)
    switch (c) {
    case 't': threads = atoi (optarg); break;
    default:
      cerr << "usage: test-queue [-t threads]" <<endl;
      exit(0);
    }
  //cout << "TESTING::  TCB.init" << endl;
  TCB.init (threads);
  

  for (int x=0; x < threads; x++) {
    TCB.push_task (new queuefiller(q, threads));
  }

  cout << "TESTING:: Starting Work" << endl;
  TCB.start_work();

  TCB.end_work();
  cout << "TESTING:: Ended Work" << endl;
  int y;
  wfqueue<int>::token tok;
  q.peek (y, tok);
  while (q.remove(y, tok)) {
    DEC(counter[y]);
    q.peek(y,tok);
  }
  // Hopefully queue will have the correct number of items

  for (int j = 0; j<10; j++)
    cout << counter[j] << endl;

  cerr << endl;
  if (false) {
    cerr << "queue test failed!" << endl;
  } else
    cerr << "queue test OK." << endl;
  //q.debugger(true);
}

