// -*- c++ -*-

#include <iostream.h>
#include "tcb.h"
#include "wfqueue.h"


#define ITEMS 1000000

int free_list_sz = 0;


static int count;


inline int random_between (int low, int high)
{
  return (int)((double)random()/INT_MAX * (high-low) + low);
}


int work () {
  int w = random_between (0, 1000);

  for (int x = 0; x < w; x++)
    ;
}
void fillqueue(wfqueue<int> & q, int r)
{
  int x;
  wfqueue<int>::token tok;
  for (int i=0; i < ITEMS; i ++) {
    q.gettoken (tok);
//    cerr << r ;
//    cerr.flush();
    work();

    if (q.insert (i, tok)) {
     
    }
  }
}

void remqueue(wfqueue<int> & q, int r)
{
  int x;
  wfqueue<int>::token tok;
  for (int i=0; i < ITEMS; i ++) {
//    cerr << r;
//    cerr.flush();
    q.peek (x, tok);
    work();
    if (q.remove ( tok)) {
      
    }

  }
}


class queuefiller : public thread_task
{
public:
  queuefiller (wfqueue<int> &q, int count) : queue (q) {
    b1.set_size(count);
    b2.set_size(count);
  }

  void action (int rank) {
    cerr << "action";
    b1.wait ();
    
    if (rank % 2) {
      fillqueue (queue, rank);
    } else {
      remqueue (queue, rank);
    }

    b2.wait();
  }

private:

  wfqueue<int> &queue;

  static thread_barrier b1;
  static thread_barrier b2;
};

thread_barrier queuefiller::b1;
thread_barrier queuefiller::b2;


thread_control TCB;

void 
main(int argc, char **argv)
{
  int c;
  int threads = 2;
  wfqueue<int> q;

  while ((c = getopt (argc, argv, "t:")) != EOF)
    switch (c) {
    case 't': threads = atoi (optarg); break;
    default:
      cerr << "usage: test-queue [-t threads]" <<endl;
      exit(0);
    }

  TCB.init (threads);
  

  for (int x=0; x < threads; x++) {
    TCB.push_task (new queuefiller(q, threads));
  }


  TCB.start_work();

  TCB.end_work();
  // Hopefully queue will have the correct number of items

  cerr << endl;
  if (false) {
    cerr << "queue test failed!" << endl;
  } else
    cerr << "queue test OK." << endl;
  //q.debugger(true);
}
